---
name: Bug report
about: Create a report to help us improve
title: ''
labels: bug

---

**⚠️IMPORTANT⚠️ if you do not fill this out, we will automatically delete your issue. We will not help anyone that cannot fill out this template.**

- [ ] Have you read our [Wiki page "Common Issues & Their Solutions"?](https://github.com/Ciphey/Ciphey/wiki/Common-Issues-&-Their-Solutions)

**Describe the bug**
A clear and concise description of what the bug is.

**Plaintext**
**⚠️IMPORTANT⚠️ The below code is non-negotiable for "Ciphey didn't decrypt...." problems. If you do not tell us your plaintext, we will not help you.** 

```
Include your plaintext here, replacing this 
```
**Version**
**⚠️IMPORTANT⚠️ We need this information because different environments will induce different bugs in Ciphey**
 - OS/Distro: [e.g. Windows, Debian 11.0, Arch, OS X El Capitan]
 - Python version: [python3 --version]
 - Ciphey versions: [python3 -m pip show ciphey cipheycore cipheydists]
 - Did you use Docker?

**Verbose Output**
**⚠️IMPORTANT⚠️ Verbose output will tell us why it's not working the way we expected it to be.**
Run Ciphey with `ciphey -vvv` and paste the results into [Pastebin.com](https://pastebin.com) or a [GitHub Gist](https://gist.github.com/)

**To Reproduce**
Steps to reproduce the behavior:
1. What input did you use?
2. What flags / arguments did you use?

**Expected behavior**
A clear and concise description of what you expected to happen.

**Any other information?**
Add any other context about the problem here.
